from rox import g
import gobject

class CellRendererBar(g.GenericCellRenderer):
	__gproperties__ = {
		'part1': (float, 'part1', 'First part',
				0, 1000000000000000, 0,
				gobject.PARAM_READWRITE),
		'part2': (float, 'part2', 'Middle part',
				0, 1000000000000000, 0,
				gobject.PARAM_READWRITE),
		'part3': (float, 'part3', 'Last part',
				0, 1000000000000000, 0,
				gobject.PARAM_READWRITE),
	}

	def __init__(self):
		self.__gobject_init__()
		self.scaled = True
		self.gcs = []
	
	def on_render(self, window, widget, background_area,
			cell_area, expose_area, flags):
		y = cell_area.y + 2
		h = cell_area.height - 4
		width = cell_area.width

		if self.scaled:
			scale = width / float(self.max)
		else:
			scale = width / \
				float(self.part1 + self.part2 + self.part3)

		gcs = self.gcs
		if not gcs:
			for colour in ('#eeeec8c81717',
				       '#f00080000000',
				       '#ffffffffffff'):
				gc = window.new_gc()
				c = g.gdk.color_parse(colour)
				gc.set_rgb_fg_color(c)
				gcs.append(gc)
		p1 = int(self.part1 * scale)
		p2 = int(self.part2 * scale)
		p3 = int(self.part3 * scale)

		window.draw_rectangle(gcs[0], True,
				cell_area.x + 1, y,
				max(0, p1 - 1), h);

		window.draw_rectangle(gcs[1], True,
				cell_area.x + p1, y,
				p2, h)

		window.draw_rectangle(gcs[2], True,
				cell_area.x + p1 + p2, y,
				max(0, p3 - 1), h)
		
		y -= 1
		h += 2

		window.draw_rectangle(widget.style.black_gc, False,
				cell_area.x, y,
				max(0, p1 + p2 + p3 - 1), h - 1)

	
	def on_get_size(self, widget, cell_area): return 0, 0, 32, 4

	def do_set_property(self, prop, value):
		setattr(self, prop.name, value)

gobject.type_register(CellRendererBar)

